import 'package:flutter/material.dart';
import 'package:font_awesome_flutter/font_awesome_flutter.dart';

class HintView extends StatelessWidget{
  String text;
  Color textColor;
  double textSize;
  IconData iconData;
  Color iconDataColor;
  double iconDataSize;
  Text textView;
  Icon iconView;
  Image imageView;
  EdgeInsets padding;
  double dividerHeight;
  double width;
  double height;

  HintView(
      {
        this.text,
        this.textColor,
        this.textSize,
        this.iconData,
        this.iconDataColor,
        this.iconDataSize,
        this.textView,
        this.iconView,
        this.imageView,
        this.padding,
        this.dividerHeight,
        this.width,
        this.height,
      }) {
    text ??= "No data to show";
    textSize ??= 22;
    iconData ??= FontAwesomeIcons.frown;
    iconDataSize ??= 96;
    dividerHeight ??= 16;
  }

  @override
  Widget build(BuildContext context) {
    return Container(
      width: width,
      height: height,
      alignment: Alignment.center,
      padding: padding ?? EdgeInsets.all(16),
      child: Column(
        crossAxisAlignment: CrossAxisAlignment.center,
        mainAxisAlignment: MainAxisAlignment.center,
        children: <Widget>[
          _getIcon(context),
          Divider(color: Colors.transparent, height: dividerHeight,),
          _getText(context),
        ],
      ),
    );
  }

  Widget _getIcon(BuildContext context){
    if(iconView != null) return iconView;
    if(imageView != null) return imageView;
    iconDataColor ??= Theme.of(context).textTheme.display1.color;
    return Icon(iconData, size: iconDataSize, color: iconDataColor,);
  }

  Widget _getText(BuildContext context){
    if(textView != null) return textView;
    textColor ??= Theme.of(context).textTheme.display1.color;
    return Center(
        child: Text(text, style: TextStyle(color: textColor, fontSize: textSize), textAlign: TextAlign.center,)
    );
  }

}